diff -urN qmail-1.03-vanilla/sha1.c qmail-1.03-md24/sha1.c
--- qmail-1.03-vanilla/sha1.c	1970-01-01 01:00:00.000000000 +0100
+++ qmail-1.03-md24/sha1.c	2007-07-19 22:31:12.000000000 +0200
@@ -0,0 +1,187 @@
+
+/**
+ * Copyright (C) 2005-2006 Tino Reichardt
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License Version 2, as
+ * published by the Free Software Foundation.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+ */
+
+#include "sha1.h"
+
+/*  define the SHA1 circular left shift macro */
+#define SHA1CircularShift(bits,word) \
+	(((word) << (bits)) | ((word) >> (32-(bits))))
+
+static void SHA1PadMessage(SHA1_CTX *);
+static void SHA1ProcessMessageBlock(SHA1_CTX *);
+
+void SHA1_Init(SHA1_CTX *ctx)
+{
+	ctx->Length_Low             = 0;
+	ctx->Length_High            = 0;
+	ctx->Message_Block_Index    = 0;
+	ctx->Intermediate_Hash[0]   = 0x67452301;
+	ctx->Intermediate_Hash[1]   = 0xEFCDAB89;
+	ctx->Intermediate_Hash[2]   = 0x98BADCFE;
+	ctx->Intermediate_Hash[3]   = 0x10325476;
+	ctx->Intermediate_Hash[4]   = 0xC3D2E1F0;
+}
+
+void SHA1_Update(SHA1_CTX *ctx, const void *data, u32 size)
+{
+	const u8 *ptr=data;
+
+	while (size--) {
+		ctx->Message_Block[ctx->Message_Block_Index++] = (*ptr & 0xFF);
+		ctx->Length_Low += 8;
+
+		if (ctx->Length_Low == 0) {
+			ctx->Length_High++;
+			if (ctx->Length_High == 0) return; /* ERR */
+		}
+
+		if (ctx->Message_Block_Index == 64) {
+			SHA1ProcessMessageBlock(ctx);
+		}
+		ptr++;
+	}
+}
+
+void SHA1_Final(u8 *Message_Digest, SHA1_CTX *ctx)
+{
+	int i;
+
+	SHA1PadMessage(ctx);
+	for(i=0; i<64; ++i) {
+		/* message may be sensitive, clear it out */
+		ctx->Message_Block[i] = 0;
+	}
+	ctx->Length_Low = 0;    /* and clear length */
+	ctx->Length_High = 0;
+	
+	for(i = 0; i < SHA1HashSize; ++i) {
+		Message_Digest[i] = ctx->Intermediate_Hash[i>>2] >> 8*(3-(i&0x03));
+	}
+}
+
+static void SHA1ProcessMessageBlock(SHA1_CTX *ctx)
+{
+	/* Constants defined in SHA-1 */
+	const u32 K[] = { 0x5A827999, 0x6ED9EBA1, 0x8F1BBCDC, 0xCA62C1D6 };
+	int t;         /* Loop counter          */
+	u32 temp;      /* Temporary word value  */
+	u32 W[80];     /* Word sequence         */
+	u32 A,B,C,D,E; /* Word buffers          */
+
+	for (t = 0; t < 16; t++) {
+		W[t] =  ctx->Message_Block[t * 4]     << 24;
+		W[t] |= ctx->Message_Block[t * 4 + 1] << 16;
+		W[t] |= ctx->Message_Block[t * 4 + 2] << 8;
+		W[t] |= ctx->Message_Block[t * 4 + 3];
+	}
+
+	for (t = 16; t < 80; t++) {
+		W[t] = SHA1CircularShift(1,W[t-3] ^
+			W[t-8] ^ W[t-14] ^ W[t-16]);
+	}
+
+	A = ctx->Intermediate_Hash[0];
+	B = ctx->Intermediate_Hash[1];
+	C = ctx->Intermediate_Hash[2];
+	D = ctx->Intermediate_Hash[3];
+	E = ctx->Intermediate_Hash[4];
+
+	for (t = 0; t < 20; t++) {
+		temp =  SHA1CircularShift(5,A) +
+			((B & C) | ((~B) & D)) + E + W[t] + K[0];
+		E = D;
+		D = C;
+		C = SHA1CircularShift(30,B);
+		B = A;
+		A = temp;
+	}
+
+	for (t = 20; t < 40; t++) {
+		temp = SHA1CircularShift(5,A) +
+			(B ^ C ^ D) + E + W[t] + K[1];
+		E = D;
+		D = C;
+		C = SHA1CircularShift(30,B);
+		B = A;
+		A = temp;
+	}
+
+	for (t = 40; t < 60; t++) {
+		temp = SHA1CircularShift(5,A) +
+		       ((B & C) | (B & D) | (C & D)) + E + W[t] + K[2];
+		E = D;
+		D = C;
+		C = SHA1CircularShift(30,B);
+		B = A;
+		A = temp;
+	}
+
+	for (t = 60; t < 80; t++) {
+		temp = SHA1CircularShift(5,A) +
+			(B ^ C ^ D) + E + W[t] + K[3];
+		E = D;
+		D = C;
+		C = SHA1CircularShift(30,B);
+		B = A;
+		A = temp;
+	}
+
+	ctx->Intermediate_Hash[0] += A;
+	ctx->Intermediate_Hash[1] += B;
+	ctx->Intermediate_Hash[2] += C;
+	ctx->Intermediate_Hash[3] += D;
+	ctx->Intermediate_Hash[4] += E;
+	ctx->Message_Block_Index = 0;
+}
+
+static void SHA1PadMessage(SHA1_CTX *ctx)
+{
+	if (ctx->Message_Block_Index > 55) {
+		ctx->Message_Block[ctx->Message_Block_Index++] = 0x80;
+
+		while (ctx->Message_Block_Index < 64) {
+			ctx->Message_Block[ctx->Message_Block_Index++] = 0;
+		}
+
+		SHA1ProcessMessageBlock(ctx);
+
+		while (ctx->Message_Block_Index < 56) {
+			ctx->Message_Block[ctx->Message_Block_Index++] = 0;
+		}
+
+	} else {
+
+		ctx->Message_Block[ctx->Message_Block_Index++] = 0x80;
+		while (ctx->Message_Block_Index < 56) {
+			ctx->Message_Block[ctx->Message_Block_Index++] = 0;
+		}
+	}
+
+	/*  Store the message length as the last 8 octets */
+	ctx->Message_Block[56] = ctx->Length_High >> 24;
+	ctx->Message_Block[57] = ctx->Length_High >> 16;
+	ctx->Message_Block[58] = ctx->Length_High >> 8;
+	ctx->Message_Block[59] = ctx->Length_High;
+	ctx->Message_Block[60] = ctx->Length_Low >> 24;
+	ctx->Message_Block[61] = ctx->Length_Low >> 16;
+	ctx->Message_Block[62] = ctx->Length_Low >> 8;
+	ctx->Message_Block[63] = ctx->Length_Low;
+
+	SHA1ProcessMessageBlock(ctx);
+}
+#undef SHA1CircularShift
diff -urN qmail-1.03-vanilla/sha1.h qmail-1.03-md24/sha1.h
--- qmail-1.03-vanilla/sha1.h	1970-01-01 01:00:00.000000000 +0100
+++ qmail-1.03-md24/sha1.h	2007-07-19 22:31:03.000000000 +0200
@@ -0,0 +1,39 @@
+#ifndef SW_SHA1_H
+#define SW_SHA1_H
+
+/**
+ * Copyright (C) 2005-2006 Tino Reichardt
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License Version 2, as
+ * published by the Free Software Foundation.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+ */
+
+#include "typesx.h"
+#include <string.h>
+
+#define SHA1HashSize 20
+
+typedef struct SHA1_CTX
+{
+    u32 Intermediate_Hash[SHA1HashSize/4]; /* Message Digest  */
+    u32 Length_Low;            /* Message length in bits      */
+    u32 Length_High;           /* Message length in bits      */
+    u32 Message_Block_Index;   /* Index into message block array   */
+    u8 Message_Block[64];      /* 512-bit message blocks      */
+} SHA1_CTX;
+
+extern void SHA1_Init(SHA1_CTX *ctx);
+extern void SHA1_Update(SHA1_CTX *ctx, const void *data, u32 size);
+extern void SHA1_Final(u8 *result, SHA1_CTX *ctx);
+
+#endif
diff -urN qmail-1.03-vanilla/sig_catch.c qmail-1.03-md24/sig_catch.c
--- qmail-1.03-vanilla/sig_catch.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-md24/sig_catch.c	2007-07-19 20:56:22.000000000 +0200
@@ -3,13 +3,18 @@
 #include "hassgact.h"
 
 void sig_catch(sig,f)
-int sig;
-void (*f)();
+  int sig;
+  void (*f)();
 {
 #ifdef HASSIGACTION
   struct sigaction sa;
   sa.sa_handler = f;
+#ifdef SA_RESTART
+  /* if available */
+  sa.sa_flags = SA_RESTART;
+#else
   sa.sa_flags = 0;
+#endif
   sigemptyset(&sa.sa_mask);
   sigaction(sig,&sa,(struct sigaction *) 0);
 #else
diff -urN qmail-1.03-vanilla/slurpclose.c qmail-1.03-md24/slurpclose.c
--- qmail-1.03-vanilla/slurpclose.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-md24/slurpclose.c	2007-07-19 20:56:22.000000000 +0200
@@ -1,3 +1,6 @@
+#include <sys/types.h>
+#include <unistd.h>
+
 #include "stralloc.h"
 #include "readwrite.h"
 #include "slurpclose.h"
diff -urN qmail-1.03-vanilla/spawn.c qmail-1.03-md24/spawn.c
--- qmail-1.03-vanilla/spawn.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-md24/spawn.c	2007-07-19 20:56:22.000000000 +0200
@@ -1,10 +1,13 @@
 #include <sys/types.h>
 #include <sys/stat.h>
+#include <unistd.h>
+
 #include "sig.h"
 #include "wait.h"
 #include "substdio.h"
 #include "byte.h"
 #include "str.h"
+#include "alloc.h"
 #include "stralloc.h"
 #include "select.h"
 #include "exit.h"
@@ -63,7 +66,7 @@
 int flagreading = 1;
 char outbuf[1024]; substdio ssout;
 
-int stage = 0; /* reading 0:delnum 1:messid 2:sender 3:recip */
+int stage = 0; /* reading 0:delnum 1:delnum2 2:messid 3:sender 4:recip */
 int flagabort = 0; /* if 1, everything except delnum is garbage */
 int delnum;
 stralloc messid = {0};
@@ -73,6 +76,7 @@
 void err(s) char *s;
 {
  char ch; ch = delnum; substdio_put(&ssout,&ch,1);
+ ch = delnum >> 8; substdio_put(&ssout,&ch,1);
  substdio_puts(&ssout,s); substdio_putflush(&ssout,"",1);
 }
 
@@ -85,44 +89,44 @@
  int pi[2];
  struct stat st;
 
- if (flagabort) { err("Zqmail-spawn out of memory. (#4.3.0)\n"); return; }
- if (delnum < 0) { err("ZInternal error: delnum negative. (#4.3.5)\n"); return; }
- if (delnum >= auto_spawn) { err("ZInternal error: delnum too big. (#4.3.5)\n"); return; }
- if (d[delnum].used) { err("ZInternal error: delnum in use. (#4.3.5)\n"); return; }
+ if (flagabort) { err("Z4.3.0 qmail-spawn out of memory\n"); return; }
+ if (delnum < 0) { err("Z4.3.5 Internal error: delnum negative\n"); return; }
+ if (delnum >= auto_spawn) { err("Z4.3.5 Internal error: delnum too big\n"); return; }
+ if (d[delnum].used) { err("Z4.3.5 Internal error: delnum in use\n"); return; }
  for (i = 0;i < messid.len;++i)
    if (messid.s[i])
      if (!i || (messid.s[i] != '/'))
        if ((unsigned char) (messid.s[i] - '0') > 9)
-        { err("DInternal error: messid has nonnumerics. (#5.3.5)\n"); return; }
- if (messid.len > 100) { err("DInternal error: messid too long. (#5.3.5)\n"); return; }
- if (!messid.s[0]) { err("DInternal error: messid too short. (#5.3.5)\n"); return; }
+        { err("D5.3.5 Internal error: messid has nonnumerics\n"); return; }
+ if (messid.len > 100) { err("D5.3.5 Internal error: messid too long\n"); return; }
+ if (!messid.s[0]) { err("D5.3.5 Internal error: messid too short\n"); return; }
 
  if (!stralloc_copys(&d[delnum].output,""))
-  { err("Zqmail-spawn out of memory. (#4.3.0)\n"); return; }
+  { err("Z4.3.0 qmail-spawn out of memory\n"); return; }
 
  j = byte_rchr(recip.s,recip.len,'@');
- if (j >= recip.len) { err("DSorry, address must include host name. (#5.1.3)\n"); return; }
+ if (j >= recip.len) { err("D5.1.3 Sorry, address must include host name\n"); return; }
 
  fdmess = open_read(messid.s);
- if (fdmess == -1) { err("Zqmail-spawn unable to open message. (#4.3.0)\n"); return; }
+ if (fdmess == -1) { err("Z4.3.0 qmail-spawn unable to open message\n"); return; }
 
  if (fstat(fdmess,&st) == -1)
-  { close(fdmess); err("Zqmail-spawn unable to fstat message. (#4.3.0)\n"); return; }
+  { close(fdmess); err("Z4.3.0 qmail-spawn unable to fstat message\n"); return; }
  if ((st.st_mode & S_IFMT) != S_IFREG)
-  { close(fdmess); err("ZSorry, message has wrong type. (#4.3.5)\n"); return; }
+  { close(fdmess); err("Z4.3.5 Sorry, message has wrong type\n"); return; }
  if (st.st_uid != auto_uidq) /* aaack! qmailq has to be trusted! */
   /* your security is already toast at this point. damage control... */
-  { close(fdmess); err("ZSorry, message has wrong owner. (#4.3.5)\n"); return; }
+  { close(fdmess); err("Z4.3.5 Sorry, message has wrong owner\n"); return; }
 
  if (pipe(pi) == -1)
-  { close(fdmess); err("Zqmail-spawn unable to create pipe. (#4.3.0)\n"); return; }
+  { close(fdmess); err("Z4.3.0 qmail-spawn unable to create pipe\n"); return; }
 
  coe(pi[0]);
 
- f = spawn(fdmess,pi[1],sender.s,recip.s,j);
+ f = spawn(fdmess,pi[1],st.st_size,sender.s,recip.s,j);
  close(fdmess);
  if (f == -1)
-  { close(pi[0]); close(pi[1]); err("Zqmail-spawn unable to fork. (#4.3.0)\n"); return; }
+  { close(pi[0]); close(pi[1]); err("Z4.3.0 qmail-spawn unable to fork\n"); return; }
 
  d[delnum].fdin = pi[0];
  d[delnum].fdout = pi[1]; coe(pi[1]);
@@ -155,16 +159,19 @@
     {
      case 0:
        delnum = (unsigned int) (unsigned char) ch;
-       messid.len = 0; stage = 1; break;
+       stage = 1; break;
      case 1:
+       delnum += (unsigned int) ((unsigned int) ch) << 8;
+       messid.len = 0; stage = 2; break;
+     case 2:
        if (!stralloc_append(&messid,&ch)) flagabort = 1;
        if (ch) break;
-       sender.len = 0; stage = 2; break;
-     case 2:
+       sender.len = 0; stage = 3; break;
+     case 3:
        if (!stralloc_append(&sender,&ch)) flagabort = 1;
        if (ch) break;
-       recip.len = 0; stage = 3; break;
-     case 3:
+       recip.len = 0; stage = 4; break;
+     case 4:
        if (!stralloc_append(&recip,&ch)) flagabort = 1;
        if (ch) break;
        docmd();
@@ -175,7 +182,7 @@
 
 char inbuf[128];
 
-void main(argc,argv)
+int main(argc,argv)
 int argc;
 char **argv;
 {
@@ -201,7 +208,8 @@
 
  initialize(argc,argv);
 
- ch = auto_spawn; substdio_putflush(&ssout,&ch,1);
+ ch = auto_spawn; substdio_put(&ssout,&ch,1);
+ ch = auto_spawn >> 8; substdio_putflush(&ssout,&ch,1);
 
  for (i = 0;i < auto_spawn;++i) { d[i].used = 0; d[i].output.s = 0; }
 
@@ -236,7 +244,8 @@
 	   continue; /* read error on a readable pipe? be serious */
 	 if (r == 0)
 	  {
-           ch = i; substdio_put(&ssout,&ch,1);
+           char ch; ch = i; substdio_put(&ssout,&ch,1);
+           ch = i >> 8; substdio_put(&ssout,&ch,1);
 	   report(&ssout,d[i].wstat,d[i].output.s,d[i].output.len);
 	   substdio_put(&ssout,"",1);
 	   substdio_flush(&ssout);
diff -urN qmail-1.03-vanilla/splogger.c qmail-1.03-md24/splogger.c
--- qmail-1.03-vanilla/splogger.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-md24/splogger.c	2007-07-19 20:56:22.000000000 +0200
@@ -45,7 +45,7 @@
   bufpos = 0;
 }
 
-void main(argc,argv)
+int main(argc,argv)
 int argc;
 char **argv;
 {
diff -urN qmail-1.03-vanilla/str_cpyb.c qmail-1.03-md24/str_cpyb.c
--- qmail-1.03-vanilla/str_cpyb.c	1970-01-01 01:00:00.000000000 +0100
+++ qmail-1.03-md24/str_cpyb.c	2007-07-19 20:56:22.000000000 +0200
@@ -0,0 +1,18 @@
+#include "str.h"
+
+unsigned int str_copyb(s,t,max)
+register char *s;
+register char *t;
+unsigned int max;
+{
+  register int len;
+
+  len = 0;
+  while (max-- > 0) {
+    if (!(*s = *t)) return len; ++s; ++t; ++len;
+    if (!(*s = *t)) return len; ++s; ++t; ++len;
+    if (!(*s = *t)) return len; ++s; ++t; ++len;
+    if (!(*s = *t)) return len; ++s; ++t; ++len;
+  }
+  return len;
+}
diff -urN qmail-1.03-vanilla/str.h qmail-1.03-md24/str.h
--- qmail-1.03-vanilla/str.h	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-md24/str.h	2007-07-19 20:56:22.000000000 +0200
@@ -1,13 +1,15 @@
 #ifndef STR_H
 #define STR_H
 
-extern unsigned int str_copy();
 extern int str_diff();
 extern int str_diffn();
+extern int str_start();
+
 extern unsigned int str_len();
 extern unsigned int str_chr();
 extern unsigned int str_rchr();
-extern int str_start();
+extern unsigned int str_copy();
+extern unsigned int str_copyb();
 
 #define str_equal(s,t) (!str_diff((s),(t)))
 
diff -urN qmail-1.03-vanilla/strsalloc.c qmail-1.03-md24/strsalloc.c
--- qmail-1.03-vanilla/strsalloc.c	1970-01-01 01:00:00.000000000 +0100
+++ qmail-1.03-md24/strsalloc.c	2007-07-19 20:56:22.000000000 +0200
@@ -0,0 +1,7 @@
+#include "alloc.h"
+#include "gen_allocdefs.h"
+#include "stralloc.h"
+#include "strsalloc.h"
+
+GEN_ALLOC_readyplus(strsalloc,stralloc,sa,len,a,i,n,x,10,strsalloc_readyplus)
+GEN_ALLOC_append(strsalloc,stralloc,sa,len,a,i,n,x,10,strsalloc_readyplus,strsalloc_append)
diff -urN qmail-1.03-vanilla/strsalloc.h qmail-1.03-md24/strsalloc.h
--- qmail-1.03-vanilla/strsalloc.h	1970-01-01 01:00:00.000000000 +0100
+++ qmail-1.03-md24/strsalloc.h	2007-07-19 20:56:22.000000000 +0200
@@ -0,0 +1,12 @@
+#ifndef STRSALLOC_H
+#define STRSALLOC_H
+
+#include "stralloc.h"
+
+#include "gen_alloc.h"
+
+GEN_ALLOC_typedef(strsalloc,stralloc,sa,len,a)
+extern int strsalloc_readyplus();
+extern int strsalloc_append();
+
+#endif
diff -urN qmail-1.03-vanilla/subfderr.c qmail-1.03-md24/subfderr.c
--- qmail-1.03-vanilla/subfderr.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-md24/subfderr.c	2007-07-19 20:56:22.000000000 +0200
@@ -2,6 +2,6 @@
 #include "substdio.h"
 #include "subfd.h"
 
-char subfd_errbuf[256];
-static substdio it = SUBSTDIO_FDBUF(write,2,subfd_errbuf,256);
+char subfd_errbuf[1024];
+static substdio it = SUBSTDIO_FDBUF(write,2,subfd_errbuf,1024);
 substdio *subfderr = &it;
diff -urN qmail-1.03-vanilla/TARGETS qmail-1.03-md24/TARGETS
--- qmail-1.03-vanilla/TARGETS	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-md24/TARGETS	2007-07-28 15:56:12.000000000 +0200
@@ -1,387 +1,354 @@
+alloc.a
+alloc.o
+alloc_re.o
+auto_break.c
+auto_break.o
 auto-ccld.sh
-make-load
-find-systype
-systype
-load
-make-compile
-compile
-fork.h
-qmail-local.o
-qmail.o
-quote.o
-now.o
-gfrom.o
-myctime.o
-slurpclose.o
-make-makelib
-makelib
+auto-gid
+auto-gid.o
+auto-int
+auto-int8
+auto-int8.o
+auto-int.o
+auto_patrn.c
+auto_patrn.o
+auto_qmail.c
+auto_qmail.o
+auto_spawn.c
+auto_spawn.o
+auto_split.c
+auto_split.o
+auto-str
+auto-str.o
+auto-uid
+auto-uid.o
+auto_uids.c
+auto_uids.o
+auto_usera.c
+auto_usera.o
+base64.o
+binm1
+binm1+df
+binm2
+binm2+df
+binm3
+binm3+df
+bouncesaying
+bouncesaying.o
+byte_chr.o
+byte_copy.o
+byte_cr.o
+byte_cspn.o
+byte_diff.o
+byte_rchr.o
+byte_rcspn.o
+byte_zero.o
+case.a
 case_diffb.o
 case_diffs.o
 case_lowerb.o
 case_lowers.o
 case_starts.o
-case.a
-getln.o
-getln2.o
-getln.a
-subgetopt.o
-sgetopt.o
-getopt.a
-sig_alarm.o
-hassgprm.h
-sig_block.o
-hassgact.h
-sig_catch.o
-sig_pause.o
-sig_pipe.o
-sig_child.o
-sig_hup.o
-sig_term.o
-sig_bug.o
-sig_misc.o
-sig.a
-open_append.o
-open_excl.o
-open_read.o
-open_trunc.o
-open_write.o
-open.a
-seek_cur.o
-seek_end.o
-seek_set.o
-seek_trunc.o
-seek.a
-hasflock.h
-lock_ex.o
-lock_exnb.o
-lock_un.o
-lock.a
-fd_copy.o
-fd_move.o
-fd.a
-haswaitp.h
-wait_pid.o
-wait_nohang.o
-wait.a
+cdb.a
+cdb_hash.o
+cdbmake.a
+cdbmake_add.o
+cdbmake_hash.o
+cdbmake_pack.o
+cdbmss.o
+cdb_seek.o
+cdb_unpack.o
+check
+chkshsgr
+chkshsgr.o
+chkspawn
+chkspawn.o
+coe.o
+commands.o
+compile
+condredirect
+condredirect.o
+config
+config-fast
+constmap.o
+control.o
+date822fmt.o
+datemail
+datetime.a
+datetime.o
+datetime_un.o
+direntry.h
+dnscname
+dnscname.o
+dnsdoe.o
+dnsfq
+dnsfq.o
+dnsip
+dnsip.o
+dns.lib
+dnsmxip
+dnsmxip.o
+dns.o
+dnsptr
+dnsptr.o
+dnstxt
+dnstxt.o
+dot-qmail.5
+elq
+env.a
 env.o
 envread.o
-env.a
-stralloc_eady.o
-stralloc_pend.o
-stralloc_copy.o
-stralloc_opys.o
-stralloc_opyb.o
-stralloc_cat.o
-stralloc_cats.o
-stralloc_catb.o
-stralloc_arts.o
-stralloc.a
-alloc.o
-alloc_re.o
-alloc.a
-strerr_sys.o
-strerr_die.o
-strerr.a
-substdio.o
-substdi.o
-substdo.o
-subfderr.o
-subfdout.o
-subfdouts.o
-subfdin.o
-subfdins.o
-substdio_copy.o
-substdio.a
+error.a
 error.o
 error_str.o
 error_temp.o
-error.a
-str_len.o
-str_diff.o
-str_diffn.o
-str_cpy.o
-str_chr.o
-str_rchr.o
-str_start.o
-byte_chr.o
-byte_rchr.o
-byte_diff.o
-byte_copy.o
-byte_cr.o
-byte_zero.o
-str.a
-fmt_str.o
+except
+except.o
+fd.a
+fd_copy.o
+fd_move.o
+fifo.o
+find-systype
+fmtqfn.o
 fmt_strn.o
-fmt_uint.o
+fmt_str.o
 fmt_uint0.o
+fmt_uint.o
 fmt_ulong.o
-scan_ulong.o
-scan_8long.o
+fork.h
+forward
+forward.o
 fs.a
-datetime.o
-datetime_un.o
-datetime.a
-auto-str.o
-auto-str
-auto_qmail.c
-auto_qmail.o
-auto-int8.o
-auto-int8
-auto_patrn.c
-auto_patrn.o
-socket.lib
-qmail-local
-uint32.h
-qmail-lspawn.o
-select.h
-chkspawn.o
-auto-int.o
-auto-int
-auto_spawn.c
-auto_spawn.o
-chkspawn
-spawn.o
-chkshsgr.o
-chkshsgr
+getln2.o
+getln.a
+getln.o
+getopt.a
+gfrom.o
+hasflock.h
+hasmkffo.h
+hasnpbg1.h
+hassalen.h
+hassgact.h
+hassgprm.h
 hasshsgr.h
-prot.o
-coe.o
-cdb_hash.o
-cdb_unpack.o
-cdb_seek.o
-cdb.a
-auto-uid.o
-auto-uid
-auto-gid.o
-auto-gid
-auto_uids.c
-auto_uids.o
-qmail-lspawn
-qmail-getpw.o
-auto_break.c
-auto_break.o
-auto_usera.c
-auto_usera.o
-qmail-getpw
-qmail-remote.o
-control.o
-constmap.o
-timeoutread.o
-timeoutwrite.o
-timeoutconn.o
-tcpto.o
-dns.o
-ip.o
+haswaitp.h
+headerbody.o
+hfield.o
+hier.o
+hmac_md5.o
+hmac_ripemd.o
+hmac_sha1.o
+home
+home+df
+hostname
+hostname.o
+idedit
+idedit.o
+install
+install-big
+install-big.o
+install.o
+instcheck
+instcheck.o
 ipalloc.o
-hassalen.h
 ipme.o
+ipmeprint
+ipmeprint.o
+ip.o
+it
+load
+lock.a
+lock_exnb.o
+lock_ex.o
+lock_un.o
+maildir2mbox
+maildir2mbox.o
+maildirmake
+maildirmake.o
+maildir.o
+maildirwatch
+maildirwatch.o
+mailsubj
+make-compile
+makelib
+make-load
+make-makelib
+man
+md5.o
+myctime.o
+ndelay.a
 ndelay.o
 ndelay_off.o
-ndelay.a
-dns.lib
-qmail-remote
-qmail-rspawn.o
-tcpto_clean.o
-qmail-rspawn
-direntry.h
-qmail-clean.o
-fmtqfn.o
-auto_split.c
-auto_split.o
-qmail-clean
-qmail-send.o
-qsutil.o
 newfield.o
+now.o
+open.a
+open_append.o
+open_excl.o
+open_read.o
+open_trunc.o
+open_write.o
+out_log.o
+pinq
+predate
+predate.o
+preline
+preline.o
 prioq.o
-hasmkffo.h
-fifo.o
-hasnpbg1.h
-trigger.o
-readsubdir.o
-date822fmt.o
-qmail-send
-qmail-start.o
-qmail-start
-splogger.o
-syslog.lib
-splogger
-qmail-queue.o
-triggerpull.o
-qmail-queue
-qmail-inject.o
-headerbody.o
-hfield.o
-token822.o
+proc
+proc+df
+prot.o
+qail
+qbiff
+qbiff.o
+qmail-clean
+qmail-clean.o
+qmail-control.5
+qmail-getpw
+qmail-getpw.8
+qmail-getpw.o
 qmail-inject
-predate.o
-predate
-datemail
-mailsubj
-qmail-upq
-qmail-showctl.o
-qmail-showctl
-qmail-newu.o
-cdbmss.o
-cdbmake_pack.o
-cdbmake_hash.o
-cdbmake_add.o
-cdbmake.a
+qmail-inject.o
+qmail-limits.7
+qmail-local
+qmail-local.o
+qmail-lspawn
+qmail-lspawn.o
+qmail-newmrh
+qmail-newmrh.8
+qmail-newmrh.o
 qmail-newu
-qmail-pw2u.o
-qmail-pw2u
-qmail-qread.o
-qmail-qread
-qmail-qstat
-qmail-tcpto.o
-qmail-tcpto
-qmail-tcpok.o
-qmail-tcpok
-qmail-pop3d.o
-commands.o
-maildir.o
+qmail-newu.8
+qmail-newu.o
+qmail.o
+qmail-p0f.o
 qmail-pop3d
-qmail-popup.o
+qmail-pop3d.o
 qmail-popup
-qmail-qmqpc.o
+qmail-popup.o
+qmail-pw2u
+qmail-pw2u.8
+qmail-pw2u.o
 qmail-qmqpc
-qmail-qmqpd.o
-received.o
+qmail-qmqpc.o
 qmail-qmqpd
-qmail-qmtpd.o
-rcpthosts.o
+qmail-qmqpd.o
 qmail-qmtpd
-qmail-smtpd.o
-qmail-smtpd
-sendmail.o
-sendmail
-tcp-env.o
-remoteinfo.o
-tcp-env
-qmail-newmrh.o
-qmail-newmrh
-config
-config-fast
-dnscname.o
-dnsdoe.o
-dnscname
-dnsptr.o
-dnsptr
-dnsip.o
-dnsip
-dnsmxip.o
-dnsmxip
-dnsfq.o
-dnsfq
-hostname.o
-hostname
-ipmeprint.o
-ipmeprint
-qreceipt.o
-qreceipt
-qsmhook.o
-qsmhook
-qbiff.o
-qbiff
-forward.o
-forward
-preline.o
-preline
-condredirect.o
-condredirect
-bouncesaying.o
-bouncesaying
-except.o
-except
-maildirmake.o
-maildirmake
-maildir2mbox.o
-maildir2mbox
-maildirwatch.o
-maildirwatch
-qail
-elq
-pinq
-idedit.o
-idedit
-install-big.o
-install.o
-install-big
-hier.o
-install
-instcheck.o
-instcheck
-home
-home+df
-proc
-proc+df
-binm1
-binm1+df
-binm2
-binm2+df
-binm3
-binm3+df
-it
-qmail-local.0
-qmail-lspawn.0
-qmail-getpw.8
-qmail-getpw.0
-qmail-remote.0
-qmail-rspawn.0
-qmail-clean.0
+qmail-qmtpd.o
+qmail-qread
+qmail-qread.o
+qmail-qstat
+qmail-queue
+qmail-queue.o
+qmail-remote
+qmail-remote.o
+qmail-rspawn
+qmail-rspawn.o
+qmail-sasl.o
+qmail-send
 qmail-send.8
-qmail-send.0
+qmail-send.o
+qmail-showctl
+qmail-showctl.o
+qmail-smtpd
+qmail-smtpd.o
+qmail-start
 qmail-start.8
-qmail-start.0
-splogger.0
-qmail-queue.0
-qmail-inject.0
-mailsubj.0
-qmail-showctl.0
-qmail-newu.8
-qmail-newu.0
-qmail-pw2u.8
-qmail-pw2u.0
-qmail-qread.0
-qmail-qstat.0
-qmail-tcpto.0
-qmail-tcpok.0
-qmail-pop3d.0
-qmail-popup.0
-qmail-qmqpc.0
-qmail-qmqpd.0
-qmail-qmtpd.0
-qmail-smtpd.0
-tcp-env.0
-qmail-newmrh.8
-qmail-newmrh.0
-qreceipt.0
-qbiff.0
-forward.0
-preline.0
-condredirect.0
-bouncesaying.0
-except.0
-maildirmake.0
-maildir2mbox.0
-maildirwatch.0
-qmail.0
-qmail-limits.7
-qmail-limits.0
-qmail-log.0
-qmail-control.5
-qmail-control.0
-qmail-header.0
+qmail-start.o
+qmail-tcpok
+qmail-tcpok.o
+qmail-tcpto
+qmail-tcpto.o
+qmail-upq
 qmail-users.5
-qmail-users.0
-dot-qmail.5
-dot-qmail.0
-qmail-command.0
-tcp-environ.0
-maildir.0
-mbox.0
-addresses.0
-envelopes.0
-forgeries.0
-man
+qreceipt
+qreceipt.o
+qsmhook
+qsmhook.o
+qsutil.o
+quote.o
+rcpthosts.o
+readsubdir.o
+realrcptto.o
+received.o
+remoteinfo.o
+ripemd.o
+scan_8long.o
+scan_ulong.o
+seek.a
+seek_cur.o
+seek_end.o
+seek_set.o
+seek_trunc.o
+select.h
+sendmail
+sendmail.o
 setup
-check
+sgetopt.o
+sha1.o
+sig.a
+sig_alarm.o
+sig_block.o
+sig_bug.o
+sig_catch.o
+sig_child.o
+sig_hup.o
+sig_misc.o
+sig_pause.o
+sig_pipe.o
+sig_term.o
+slurpclose.o
+socket.lib
+spawn.o
+splogger
+splogger.o
+str.a
+stralloc.a
+stralloc_arts.o
+stralloc_catb.o
+stralloc_cat.o
+stralloc_cats.o
+stralloc_copy.o
+stralloc_eady.o
+stralloc_opyb.o
+stralloc_opys.o
+stralloc_pend.o
+str_chr.o
+str_cpyb.o
+str_cpy.o
+str_diffn.o
+str_diff.o
+strerr.a
+strerr_die.o
+strerr_sys.o
+str_len.o
+str_rchr.o
+strsalloc.o
+str_start.o
+subfderr.o
+subfdin.o
+subfdins.o
+subfdout.o
+subfdouts.o
+subgetopt.o
+substdi.o
+substdio.a
+substdio_copy.o
+substdio.o
+substdo.o
+syslog.lib
+systype
+tcp-env
+tcp-env.o
+tcpto_clean.o
+tcpto.o
+timeoutconn.o
+timeoutread.o
+timeoutwrite.o
+token822.o
+trigger.o
+triggerpull.o
+ucspitls.o
+uint32.h
+wait.a
+wait_nohang.o
+wait_pid.o
diff -urN qmail-1.03-vanilla/tcp-env.c qmail-1.03-md24/tcp-env.c
--- qmail-1.03-vanilla/tcp-env.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-md24/tcp-env.c	2007-07-19 20:56:22.000000000 +0200
@@ -2,6 +2,8 @@
 #include <sys/socket.h>
 #include <sys/param.h>
 #include <netinet/in.h>
+#include <unistd.h>
+
 #include "sig.h"
 #include "stralloc.h"
 #include "str.h"
@@ -10,6 +12,7 @@
 #include "scan.h"
 #include "subgetopt.h"
 #include "ip.h"
+#include "strsalloc.h"
 #include "dns.h"
 #include "byte.h"
 #include "remoteinfo.h"
@@ -30,10 +33,11 @@
 
 char temp[IPFMT + FMT_ULONG];
 
-void main(argc,argv)
+int main(argc,argv)
 int argc;
 char *argv[];
 {
+ strsalloc ssa = {0};
  int dummy;
  char *proto;
  int opt;
@@ -74,12 +78,13 @@
    temp[ip_fmt(temp,&iplocal)] = 0;
    if (!env_put2("TCPLOCALIP",temp)) die();
 
-   switch(dns_ptr(&localname,&iplocal))
+   switch(dns_ptr(&ssa,&iplocal))
     {
      case DNS_MEM: die();
      case DNS_SOFT:
        if (!stralloc_copys(&localname,"softdnserror")) die();
      case 0:
+       if (!stralloc_copy(&localname,&ssa.sa[0])) die();
        if (!stralloc_0(&localname)) die();
        case_lowers(localname.s);
        if (!env_put2("TCPLOCALHOST",localname.s)) die();
@@ -99,12 +104,13 @@
    temp[ip_fmt(temp,&ipremote)] = 0;
    if (!env_put2("TCPREMOTEIP",temp)) die();
 
-   switch(dns_ptr(&remotename,&ipremote))
+   switch(dns_ptr(&ssa,&ipremote))
     {
      case DNS_MEM: die();
      case DNS_SOFT:
        if (!stralloc_copys(&remotename,"softdnserror")) die();
      case 0:
+       if (!stralloc_copy(&remotename,&ssa.sa[0])) die();
        if (!stralloc_0(&remotename)) die();
        case_lowers(remotename.s);
        if (!env_put2("TCPREMOTEHOST",remotename.s)) die();
@@ -125,5 +131,5 @@
 
  sig_pipedefault();
  execvp(*argv,argv);
- die();
+ return 111;
 }
diff -urN qmail-1.03-vanilla/tcpto.c qmail-1.03-md24/tcpto.c
--- qmail-1.03-vanilla/tcpto.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-md24/tcpto.c	2007-07-19 20:56:22.000000000 +0200
@@ -73,7 +73,7 @@
  int i;
  char *record;
  datetime_sec when;
- datetime_sec firstwhen;
+ datetime_sec firstwhen=0;
  int firstpos;
  datetime_sec lastwhen;
 
diff -urN qmail-1.03-vanilla/tcpto_clean.c qmail-1.03-md24/tcpto_clean.c
--- qmail-1.03-vanilla/tcpto_clean.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-md24/tcpto_clean.c	2007-07-19 20:56:22.000000000 +0200
@@ -1,3 +1,5 @@
+#include <sys/types.h>
+#include <unistd.h>
 #include "tcpto.h"
 #include "open.h"
 #include "substdio.h"
diff -urN qmail-1.03-vanilla/timeoutconn.c qmail-1.03-md24/timeoutconn.c
--- qmail-1.03-vanilla/timeoutconn.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-md24/timeoutconn.c	2007-07-19 20:56:22.000000000 +0200
@@ -10,38 +10,46 @@
 #include "byte.h"
 #include "timeoutconn.h"
 
-int timeoutconn(s,ip,port,timeout)
-int s;
-struct ip_address *ip;
-unsigned int port;
-int timeout;
+int timeoutconn(s,ip,outip,port,timeout)
+  int s;
+  struct ip_address *ip;
+  struct ip_address *outip;
+  unsigned int port;
+  int timeout;
 {
   char ch;
   struct sockaddr_in sin;
   char *x;
   fd_set wfds;
   struct timeval tv;
- 
+
+  /* bind() an outgoing ipaddr */
+  byte_zero(&sin,sizeof(sin));
+  byte_copy(&sin.sin_addr.s_addr,4,outip);
+  sin.sin_family = AF_INET;
+
+  if (-1 == bind(s,(struct sockaddr *) &sin,sizeof(sin))) return -1;
+
   byte_zero(&sin,sizeof(sin));
   byte_copy(&sin.sin_addr,4,ip);
   x = (char *) &sin.sin_port;
   x[1] = port; port >>= 8; x[0] = port;
   sin.sin_family = AF_INET;
- 
+
   if (ndelay_on(s) == -1) return -1;
- 
+
   /* XXX: could bind s */
- 
+
   if (connect(s,(struct sockaddr *) &sin,sizeof(sin)) == 0) {
     ndelay_off(s);
     return 0;
   }
   if ((errno != error_inprogress) && (errno != error_wouldblock)) return -1;
- 
+
   FD_ZERO(&wfds);
   FD_SET(s,&wfds);
   tv.tv_sec = timeout; tv.tv_usec = 0;
- 
+
   if (select(s + 1,(fd_set *) 0,&wfds,(fd_set *) 0,&tv) == -1) return -1;
   if (FD_ISSET(s,&wfds)) {
     int dummy;
@@ -53,7 +61,7 @@
     ndelay_off(s);
     return 0;
   }
- 
+
   errno = error_timeout; /* note that connect attempt is continuing */
   return -1;
 }
diff -urN qmail-1.03-vanilla/trigger.c qmail-1.03-md24/trigger.c
--- qmail-1.03-vanilla/trigger.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-md24/trigger.c	2007-07-19 20:56:22.000000000 +0200
@@ -1,3 +1,5 @@
+#include <sys/types.h>
+#include <unistd.h>
 #include "select.h"
 #include "open.h"
 #include "trigger.h"
diff -urN qmail-1.03-vanilla/triggerpull.c qmail-1.03-md24/triggerpull.c
--- qmail-1.03-vanilla/triggerpull.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-md24/triggerpull.c	2007-07-19 20:56:22.000000000 +0200
@@ -1,3 +1,5 @@
+#include <sys/types.h>
+#include <unistd.h>
 #include "ndelay.h"
 #include "open.h"
 #include "triggerpull.h"
diff -urN qmail-1.03-vanilla/trycpp.c qmail-1.03-md24/trycpp.c
--- qmail-1.03-vanilla/trycpp.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-md24/trycpp.c	2007-07-19 20:56:22.000000000 +0200
@@ -1,4 +1,4 @@
-void main()
+int main()
 {
 #ifdef NeXT
   printf("nextstep\n"); exit(0);
diff -urN qmail-1.03-vanilla/tryflock.c qmail-1.03-md24/tryflock.c
--- qmail-1.03-vanilla/tryflock.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-md24/tryflock.c	2007-07-19 20:56:22.000000000 +0200
@@ -2,7 +2,7 @@
 #include <sys/file.h>
 #include <fcntl.h>
 
-void main()
+int main()
 {
   flock(0,LOCK_EX | LOCK_UN | LOCK_NB);
 }
diff -urN qmail-1.03-vanilla/trymkffo.c qmail-1.03-md24/trymkffo.c
--- qmail-1.03-vanilla/trymkffo.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-md24/trymkffo.c	2007-07-19 20:56:22.000000000 +0200
@@ -1,7 +1,7 @@
 #include <sys/types.h>
 #include <sys/stat.h>
 
-void main()
+int main()
 {
   mkfifo("temp-trymkffo",0);
 }
diff -urN qmail-1.03-vanilla/trynpbg1.c qmail-1.03-md24/trynpbg1.c
--- qmail-1.03-vanilla/trynpbg1.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-md24/trynpbg1.c	2007-07-19 20:56:22.000000000 +0200
@@ -4,7 +4,7 @@
 
 #define FN "temp-trynpbg1.fifo"
 
-void main()
+int main()
 {
   int flagbug;
   struct timeval instant;
diff -urN qmail-1.03-vanilla/trysgact.c qmail-1.03-md24/trysgact.c
--- qmail-1.03-vanilla/trysgact.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-md24/trysgact.c	2007-07-19 20:56:22.000000000 +0200
@@ -1,6 +1,6 @@
 #include <signal.h>
 
-void main()
+int main()
 {
   struct sigaction sa;
   sa.sa_handler = 0;
diff -urN qmail-1.03-vanilla/trysgprm.c qmail-1.03-md24/trysgprm.c
--- qmail-1.03-vanilla/trysgprm.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-md24/trysgprm.c	2007-07-19 20:56:22.000000000 +0200
@@ -1,6 +1,6 @@
 #include <signal.h>
 
-void main()
+int main()
 {
   sigset_t ss;
  
